unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  StdCtrls, Menus, ActnList,fpjson, jsonparser,TypInfo;

type

  { TForm1 }

  TForm1 = class(TForm)
    ZurueckButton: TButton;
    VorButton: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    DateiOeffnen: TMenuItem;
    ProgrammBeenden: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure DateiOeffnenClick(Sender: TObject);
    procedure ProgrammBeendenClick(Sender: TObject);
    procedure VorButtonClick(Sender: TObject);
    procedure ZurueckButtonClick(Sender: TObject);
    procedure getKeyandValue();
  private

  public

  end;

var
  Form1    : TForm1;
  jData    : TJSONData;
  lauf     : integer;
  maxCount : integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.getKeyandValue();
begin
  Label1.Caption := 'Key '  +IntToStr(lauf+1);
  Label2.Caption := 'Value '+IntToStr(lauf+1);
  Edit1.Text := TJSONObject(jData.Items[0].Items[0]).Names[lauf];
  Edit2.Text := jData.Items[0].Items[0].Items[lauf].AsString;
end;

procedure TForm1.VorButtonClick(Sender: TObject);

begin
  lauf +=1;
  if lauf > maxCount-1 then lauf := 0;
  getKeyandValue;
end;

procedure TForm1.ZurueckButtonClick(Sender: TObject);
begin
  lauf -=1;
  if lauf < 0 then lauf := maxCount-1;
  getKeyandValue;

end;

procedure TForm1.DateiOeffnenClick(Sender: TObject);
var
  sourceStream  : TFileStream;

begin

  if opendialog1.Execute then
   begin
      sourceStream := TFileStream.Create( opendialog1.FileName, fmOpenRead);
      jData := GetJSON(sourceStream);
      memo1.Clear;
      memo1.Text:= jData.FormatJSON;
      maxCount := TJSONObject(jData.Items[0].Items[0]).Count;

      VorButton.Enabled:= true;
      ZurueckButton.Enabled:= true;
      getKeyandValue;
      sourceStream.Free;
    end
   else
     ShowMessage('Sie müssen zuerst eine Datei laden!');
  end;


procedure TForm1.ProgrammBeendenClick(Sender: TObject);
begin
  close;
end;

end.

